package org.jeecg.modules.app.service;

import org.jeecg.modules.app.vo.OrderVO;

import java.util.Date;

public interface IOrderService {

    /**
     * @Author SheepHy
     * @Description 学校场地预约-创建
     * @Date 10:10 2025/7/14
     * @Param
     * @return
     **/
//    String createOrderPlaceSchool(String name);

    /**
     * @Author SheepHy
     * @Description 课程库存校验
     * @Date 16:22 2025/7/14
     * @Param courseId 课程ID
     * @return boolean
     **/
    boolean checkCourseInventory(String courseId);

    /**
     * @Author SheepHy
     * @Description 学校场地预约-预览页
     * @Date 10:10 2025/7/14
     * @Param placeId startTime
     * @return OrderVO.PreviewOrderPlaceSchool {@link OrderVO.PreviewOrderPlaceSchool}
     **/
    OrderVO.PreviewOrderPlaceSchool previewOrderPlaceSchool(String placeId, Date startTime);

    /**
     * @Author SheepHy
     * @Description 课程购买-预览页（学校课程、体育馆课程、教练课程）
     * @Date 15:43 2025/7/14
     * @Param courseId
     * @return OrderVO.PreviewOrderCourseSchool {@link OrderVO.PreviewOrderCourse}
     **/
    OrderVO.PreviewOrderCourse previewOrderCourse(String courseId);

    /**
     * @Author SheepHy
     * @Description 体育馆包场-预览页
     * @Date 16:13 2025/7/14
     * @Param placeId
     * @return OrderVO.PreviewOrderPlaceGymnasiumChartered {@link OrderVO.PreviewOrderPlaceGymnasiumChartered}
     **/
    OrderVO.PreviewOrderPlaceGymnasiumChartered previewOrderPlaceGymnasiumChartered(String placeId);
}
