package org.jeecg.modules.app.vo;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="公共订单相关返回参数")
public class OrderVO {
    @Data
    @Accessors(chain = true)
    @EqualsAndHashCode(callSuper = false)
    @Schema(description="学校场地预约-预览页")
    public static class PreviewOrderPlaceSchool {
        @Schema(description = "门店ID")
        private String id;
        @Schema(description = "门店名称")
        private String name;
        @Schema(description="学校场地预约-预览页-时间段")
        private List<PreviewOrderPlaceSchoolChild> timeSlot;

    }

    @Data
    @Accessors(chain = true)
    @EqualsAndHashCode(callSuper = false)
    @Schema(description="学校场地预约-预览页-时间段")
    public static class PreviewOrderPlaceSchoolChild {
        @Schema(description = "时间段ID")
        private String id;
        @Schema(description = "时间段名称")
        private String name;
        @Schema(description = "库存")
        private int inventory;
        @Schema(description = "价格")
        private BigDecimal price;

    }

    @Data
    @Accessors(chain = true)
    @EqualsAndHashCode(callSuper = false)
    @Schema(description="课程购买-预览页")
    public static class PreviewOrderCourse {
        @Schema(description = "课程ID")
        private String id;
        @Schema(description = "课程名称")
        private String name;
        @Schema(description = "课程图片")
        private String cover;
        @Schema(description = "商品总价")
        private BigDecimal totalPrice;
        @Schema(description = "优惠")
        private BigDecimal discountPrice;
        @Schema(description = "小计")
        private BigDecimal subtotal;
        @Schema(description = "合计")
        private BigDecimal total;
        @Schema(description = "总优惠")
        private BigDecimal totalDiscount;
        @Schema(description = "提交金额")
        private BigDecimal amount;
        @Schema(description = "提示")
        private String reminder;
    }

    @Data
    @Accessors(chain = true)
    @EqualsAndHashCode(callSuper = false)
    @Schema(description="体育馆包场-预览页")
    public static class PreviewOrderPlaceGymnasiumChartered {
        @Schema(description = "场地ID")
        private String placeId;
        @Schema(description = "体育馆包场提前退款时间；单位：分钟")
        private int earlyRefundTime;
        @Schema(description = "门店名称")
        private String storeName;
        @Schema(description = "场地名称")
        private String placeName;
        @Schema(description = "商品总价")
        private BigDecimal totalPrice;
        @Schema(description = "小计")
        private BigDecimal subtotal;
        @Schema(description = "购买人手机号")
        private String mobile;
        @Schema(description = "提示")
        private String reminder;
        @Schema(description = "退改规则")
        private String refundRule;
        @Schema(description="体育馆包场-时间段-预览页")
        private List<PreviewOrderTimePeriod> timePeriod;

    }
    @Data
    @Accessors(chain = true)
    @EqualsAndHashCode(callSuper = false)
    @Schema(description="体育馆包场-时间段-预览页")
    public static class PreviewOrderTimePeriod{
        @Schema(description = "时间段ID")
        private String id;
        @Schema(description = "时间段名称")
        private String name;
        @Schema(description = "开始时间")
        private Date startTime;
        @Schema(description = "结束时间")
        private Date endTime;
    }
}
